/* $Id: mz700win.h,v 1.2 2000/10/10 18:37:35 marukun Exp $ */

/* Typedef */
typedef		unsigned int UINT32;
typedef		unsigned short UINT16;
typedef		unsigned char UINT8;

/* bZ[Wœ{g */
#define JAPANESE		0

/* */
#define ROM_START	0			/* monitor rom */
#define ROM2_START	(4*1024)	/* monitor rom-2 */
#define VID_START	(10*1024)	/* video ram */
#define RAM_START	(14*1024)	/* 64k normal ram */

/* */
#define ROM1_ADDR 0x0000		/* ROM1 mz addr */
#define ROM2_ADDR 0xE800		/* ROM2 mz addr */

#define MZ1R12_SIZE 0x8000		/* MZ-1R12̃TCY(32k) */
#define MZ1R12_MAX	64			/* MZ-1R12̍ő呕 */
#define MZ1R18_SIZE 0x10000		/* MZ-1R18̃TCY(64k) */

#define ROMFONT_SIZE 4096		/* ROMFONT SIZE  */
#define PCG700_SIZE 2048		/* PCG-700 SIZE  */
#define PCG1500_SIZE 8192		/* PCG 1BANK SIZE  */

#define CPU_SPEED 3580000		/* 3.580 MHz */
#define CPU_SPEED_BASE 3580000	/* 3.580 MHz */
#define FRAMES_PER_SECOND 60
#define PIO_TIMER_RESO 10

#define VRAM_ACCESS_WAIT 42
#define TEMPO_TSTATES ((CPU_SPEED*10)/381/2)
#define VBLANK_TSTATES 45547	

/* j^qnlP̃^Cv萔 */
enum TMON1_TYPE
{
	MON_EMUL = 0,														/*  0:EMUL ROM(NO ROM FILE) */
	MON_OTHERS,															/*  1:OTHERS */
	MON_1Z009,															/*  2:1Z-009A/B */
	MON_1Z013,															/*  3:1Z-013A/B */
	MON_NEWMON700,														/*  4:MZ700-NEW MONITOR */
	MON_NEWMON80K,														/*  5:MZ-NEW MONITOR */

	MON_LAST,
};

/* j^qnlQ̃^Cv萔 */
enum TMON2_TYPE
{
	MON_9Z502 = 1,														/*  1:9Z-502M */
};

/* MZTt@C̃wb_ */
typedef struct
{
	BYTE mz_fmode;														/* lỹt@C[h */
	BYTE mz_filename[17];												/* lỹt@C */
	WORD mz_filesize;													/* t@CTCY */
	WORD mz_topaddr;													/* 擪AhX */
	WORD mz_execaddr;													/* sAhX */
	
	BYTE dummy[0x80-0x18];												/* pfBO */
} MZTHED;

/* L[e[u Patchp\ */
typedef struct
{
	WORD addr;															/* patch address */
	BYTE data;															/* patch data */
	
} TPATCH;

/* for MONITOR PATCH */	
typedef struct
{
	WORD addr;															/* patch addr */
	unsigned short code;												/* em code */
} TMONEMU;
