//----------------------------------------------------------------------------
// File:MZddraw.cpp
//
// mz700win:DirectDraw Module
// ($Id: Mzddraw.cpp,v 1.1.1.1 2000/08/20 13:23:04 marukun Exp $)
// Programmed by Takeshi Maruyama
//----------------------------------------------------------------------------

#include <windows.h>

#include "mz700win.h"
#include "win.h"
#include "MZddraw.h"
#include "MZscrn.h"

static TSCRSIZE fullscrsize[] =
{
	{ 320,200,  0,  0,320,200 },
	{ 320,240,  0, 20,320,200 },
	{ 640,400,  0,  0,640,400 },
	{ 640,480,  0, 40,640,400 }
	
};

/* DirectDraw\ */
static LPDIRECTDRAW2           lpDD2 = NULL;           /* DirectDraw2IuWFNg */
static LPDIRECTDRAWSURFACE     lpFRONTBUFFER = NULL;   /* \obt@ */
static LPDIRECTDRAWSURFACE     lpBACKBUFFER = NULL;    /* obt@ */
static LPDIRECTDRAWSURFACE     lpBACKBUFFER2 = NULL;   /* obt@Q */
static LPDIRECTDRAWSURFACE     lpBITMAP = NULL;        /* p^[ */
static LPDIRECTDRAWPALETTE     lpPALETTE = NULL;       /* pbg */
static LPDIRECTDRAWCLIPPER     lpCLIP = NULL;			/* Nbv */

static DWORD	nowsynctime;							/* ݂̃^C}[ */
static DWORD	nextsynctime;							/* tbv^C}[l */

/* DirectDraw[N */
static DDSURFACEDESC	ddsd;
static DDSCAPS			ddscaps;
static DDBLTFX		    ddbltfx;	
static DDBLTFX			ddbltfx_cls;

/********************/
/* DirectDraw̍쐬 */
/********************/
BOOL CreateDirectDraw(HWND hwnd)
{
//	DDCAPS	DDDriverCaps;
//	DDCAPS	DDHELCaps;
	LPDIRECTDRAW lpDD = NULL;									/* DirectDrawIuWFNg */
	
    /* DirectDraw̏ */
    if (DirectDrawCreate(NULL, &lpDD, NULL) != DD_OK)
	{
    	MessageBox(hwnd, "DirectDraw initialize failed !",
				   "Error", MB_ICONERROR);
		return FALSE;
	}
	
	if (lpDD->QueryInterface(IID_IDirectDraw2,(LPVOID *)&lpDD2) != DD_OK)
	{
		if (lpDD != NULL) { lpDD->Release();lpDD=NULL; }
		return FALSE;
	}

	if (lpDD != NULL) { lpDD->Release();lpDD=NULL; }

	/* DDBLTFXp[N쐬 */
    ZeroMemory(&ddbltfx, sizeof(DDBLTFX));
    ddbltfx.dwSize = sizeof(DDBLTFX);
	
	/* ^C}[̏ */
	nowsynctime = get_timer();
	nextsynctime = nowsynctime + SyncTime;
    ZeroMemory(&ddbltfx_cls, sizeof(DDBLTFX));							/* ClearScreenp[N */

	return TRUE;
}

/****************************************/
/* DirectDraw̏itXN[j */
/****************************************/
BOOL InitDirectDrawFull(HWND hwnd, int xsize, int ysize)
{
	HRESULT ddchk;

	/* Set Exclusive */
    lpDD2->SetCooperativeLevel(hwnd,
                            DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN);
//                            DDSCL_EXCLUSIVE|DDSCL_FULLSCREEN|DDSCL_ALLOWREBOOT);
	
	ddchk=lpDD2->SetDisplayMode(xsize, ysize, 8, 0, 0);
	if (ddchk != DD_OK)
	{
		lpDD2->SetCooperativeLevel(hwnd, DDSCL_NORMAL);
		return FALSE;
	}

	return MakeScreenSurface();
}

/************************************/
/* tXN[pT[tFX̍쐬 */
/************************************/
BOOL MakeScreenSurface(void)
{
	HRESULT ddchk;
	DDCAPS	DDDriverCaps;
	DDCAPS	DDHELCaps;

	/* DirectDrawhCo̔\͂f */
	ZeroMemory(&DDDriverCaps,sizeof(DDDriverCaps));
	DDDriverCaps.dwSize=sizeof(DDDriverCaps);
	ZeroMemory(&DDHELCaps,sizeof(DDHELCaps));
	DDHELCaps.dwSize=sizeof(DDHELCaps);
	
	lpDD2->GetCaps(&DDDriverCaps,&DDHELCaps);

    /* \obt@̏ */
    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS|DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps =
        DDSCAPS_PRIMARYSURFACE|DDSCAPS_FLIP|DDSCAPS_COMPLEX;
	
	/* uq`leʂɂBack Buffer̐߂ */
    ddsd.dwBackBufferCount = 2;
	if (DDDriverCaps.dwVidMemFree <= 0x200000) ddsd.dwBackBufferCount--;

	/* vC}T[tFX̍쐬 */
	lpDD2->CreateSurface(&ddsd, &lpFRONTBUFFER, NULL);

    /* obt@̏ */
    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;
    ddchk = lpFRONTBUFFER->GetAttachedSurface(&ddscaps, &lpBACKBUFFER);
	if (ddchk != DD_OK)
	{
    	MessageBox(hwndApp, "GetAttachedSurface Error!",
				   "Error", MB_ICONERROR);
		return FALSE;
	}

    /* pbg̐tgobt@ɌѕtB */
	if (lpPALETTE) { lpPALETTE->Release(); lpPALETTE=NULL; }
    lpDD2->CreatePalette(DDPCAPS_8BIT, &LogicalPalette.aEntries[0], &lpPALETTE, NULL);
    lpFRONTBUFFER->SetPalette(lpPALETTE);

	/* Ƃ肠T[tFXNA */
	ClearScreen();
	
	return TRUE;
}

/**********************************************************/
/* XvCgT[tFXƃtgobt@ƃpbgj */
/**********************************************************/
void ReleaseDirectDraw(void)
{
////	if (scrnmode==SCRN_WINDOW) lpDD2->RestoreDisplayMode();
//	if (scrnmode==SCRN_WINDOW && lpCLIP!=NULL) lpFRONTBUFFER->SetClipper(0);

    if (lpCLIP != NULL) { lpCLIP->Release();lpCLIP=NULL; }
    if (lpPALETTE != NULL) { lpPALETTE->Release();lpPALETTE=NULL; }
    if (lpBITMAP != NULL) { lpBITMAP->Release();lpBITMAP = NULL; }
    if (lpFRONTBUFFER != NULL) { lpFRONTBUFFER->Release();lpFRONTBUFFER=NULL;lpBACKBUFFER=NULL;lpCLIP=NULL; }
}

/********************/
/* DirectDraw̏I */
/********************/
void EndDirectDraw(void)
{
	HANDLE hProcess = GetCurrentProcess();
	
	// EBhEł΁AvZX̗Dxʏ
	if (hProcess)
	{
		SetPriorityClass(hProcess, NORMAL_PRIORITY_CLASS);
	}
		
	ReleaseDirectDraw();												/* XvCgT[tFXƃtgobt@ƃpbgj */
    if (lpDD2 != NULL) { lpDD2->Release();lpDD2=NULL; }
}

/**************/
/* ʂ̏ */
/**************/
void ClearScreen(void)
{
    ddbltfx_cls.dwSize = sizeof(DDBLTFX);

	lpFRONTBUFFER->Blt(NULL, NULL, NULL,
					  DDBLT_COLORFILL|DDBLT_WAIT, &ddbltfx_cls);
}

/****************/
/* Sʃ[h */
/****************/
int ChangeToFullScreen(void)
{
	int result = -1;
	int i;

	for (i=0;i<FULL_END;i++)
	{
		if (InitDirectDrawFull(hwndApp,fullscrsize[i].xscr,fullscrsize[i].yscr))
		{
			result = i;
			break;
		}
	}

	return result;
}



/***********************/
/* Redraw Window Frame */
/***********************/
void redraw_win_frame(HWND hwnd)
{
	if (lpFRONTBUFFER != NULL)
	{
		lpDD2->FlipToGDISurface();
		DrawMenuBar(hwnd);
		RedrawWindow(hwnd, NULL, NULL, RDW_FRAME);
	}

}

/*******************************/
/* GDIDirectDraŵ荇킹 */
/*******************************/
void flip2gdi(void)
{
	lpDD2->FlipToGDISurface();
}

/********************/
/* EBhEɕ` */
/********************/
void update_winscr(void)
{
	HDC hdc;
	HRESULT ddchk;
	RECT destrect;
	POINT pt;
	TSCRSIZE *tscrp;

	if (get_scrnmode()==SCRN_WINDOW)
	{
		/* Normal Window */
		hdc = GetDC(hwndApp);
		if (hdc)
		{
			switch (menu.screen)
			{
				/* 1:1 */
			case 0:
				BitBlt(hdc,0,0,FORMWIDTH,FORMHEIGHT,Buffer,0,0,SRCCOPY);
				break;
				/* 2:2 */
			case 1:
				StretchBlt(hdc,0,0,FORMWIDTH<<1,FORMHEIGHT<<1,
						   Buffer,0,0,FORMWIDTH,FORMHEIGHT,SRCCOPY);
				break;
			}
			
			ReleaseDC(hwndApp,hdc);
		}
	}
	else
	{
		// Full Screen
		if (lpFRONTBUFFER==NULL) return;								/* BACKBUFFERȂreturn */
	
		/* Full-Screen */
		if (lpFRONTBUFFER->IsLost())
		{
			lpFRONTBUFFER->Release();
			lpFRONTBUFFER=NULL;
			
			if (MakeScreenSurface())
			{
				mz_refresh_screen(REFSC_ALL);
				// vZX̗DxDɖ߂
				HANDLE hProcess = GetCurrentProcess();
				if (hProcess)
				{
					SetPriorityClass(hProcess, HIGH_PRIORITY_CLASS);
				}
			}
			else return;
		}

		GetClientRect(hwndApp,&destrect);								/* ̃EBhE̋` */
		pt.x = 0;
		pt.y = 0;
		ClientToScreen(hwndApp,&pt);
		OffsetRect(&destrect,pt.x,pt.y);								/* destEBhE̋` */

		ddchk = lpFRONTBUFFER->GetDC(&hdc);
		if (ddchk == DD_OK)
		{
			tscrp = &fullscrsize[get_fullmode()];
			if (tscrp->xsiz == FORMWIDTH)
			{
				BitBlt(hdc,tscrp->xpos,tscrp->ypos,FORMWIDTH,FORMHEIGHT,Buffer,0,0,SRCCOPY);
			}
			else
			{
				StretchBlt(hdc,tscrp->xpos,tscrp->ypos,tscrp->xsiz,tscrp->ysiz,
						   Buffer,0,0,FORMWIDTH,FORMHEIGHT,SRCCOPY);

			}
			ddchk = lpFRONTBUFFER->ReleaseDC(hdc);
		}
		
	}
	
}
