//----------------------------------------------------------------------------
// File:fileio.c
//
// mz700win:File Access Module
// ($Id: fileio.c,v 1.2 2000/08/20 17:57:15 marukun Exp $)
// Programmed by Takeshi Maruyama
//----------------------------------------------------------------------------

#include <windows.h>
#include "fileio.h"

//----------------------------------------------------------
// t@CǂݍݗpOpen
//----------------------------------------------------------
// Ret: t@Cnh
//      FILE_VAL_ERROR = Open Error
FILE_HDL FILE_ROPEN(LPCSTR filename)
{
    FILE_HDL fh;

	fh = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, 0,
		OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);

    return fh;
}

//----------------------------------------------------------
// t@CVK쐬pOpen
//----------------------------------------------------------
// Ret: t@Cnh
//      FILE_VAL_ERROR = Open Error
FILE_HDL FILE_COPEN(LPCSTR filename)
{
    FILE_HDL fh;

	fh = CreateFile(filename, GENERIC_WRITE, 0, 0,
			CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

    return fh;
}

//----------------------------------------------------------
// t@Cǉ쐬pOpen
//----------------------------------------------------------
// Ret: t@Cnh
//      FILE_VAL_ERROR = Open Error
FILE_HDL FILE_AOPEN(LPCSTR filename)
{
    FILE_HDL fh;

    fh = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, 0, 0,
                    OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
    if (fh == INVALID_HANDLE_VALUE)
    {
        fh = CreateFile(filename, GENERIC_WRITE, 0, 0,
                        CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
     }

    if (fh != INVALID_HANDLE_VALUE)
    {
        SetFilePointer(fh, 0, NULL, FILE_END);
    }

    return fh;
}

//----------------------------------------------------------
// t@Cǂݍ
//----------------------------------------------------------
// Ret: ǂݍ݃oCgF|PG[
int FILE_READ(FILE_HDL fh, void * ptr, int sz)
{
    BOOL result;
    DWORD rbytes;

	result = ReadFile(fh, ptr, sz, &rbytes, NULL);

    return (result) ? rbytes : -1;
}

//----------------------------------------------------------
// t@C
//----------------------------------------------------------
// Ret: ݃oCgF|PG[
int FILE_WRITE(FILE_HDL fh, void * ptr, int sz)
{
    BOOL result;
    DWORD wbytes;

	result = WriteFile(fh, ptr, sz, &wbytes, NULL);

    return (result) ? wbytes : -1;
}

//----------------------------------------------------------
// t@CN[Y
//----------------------------------------------------------
// Ret: ݃oCgF|PG[
BOOL FILE_CLOSE(FILE_HDL fh)
{
    return CloseHandle(fh);
}


//----------------------------------------------------------
// t@CV[N
//----------------------------------------------------------
// Ret: t@C̃JgʒuF|PG[
int FILE_SEEK(FILE_HDL fh, long pointer, int mode)
{
	return SetFilePointer(fh, pointer, NULL, mode);
}

//----------------------------------------------------------
// t@C݂邩ǂ`FbN
//----------------------------------------------------------
BOOL FileExists(LPCSTR filename)
{
	FILE_HDL fp;

	fp = FILE_ROPEN(filename);
	if (fp == FILE_VAL_ERROR) return FALSE;

	FILE_CLOSE(fp);
	return TRUE;
}

